----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 10/25/2022 07:35:53 PM
-- Design Name: 
-- Module Name: adder4bits - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

ENTITY adder4bits IS
    PORT (
        cin : IN STD_LOGIC;
        a : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
        b : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
        s : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
        cout : OUT STD_LOGIC);
END adder4bits;

ARCHITECTURE Behavioral OF adder4bits IS
    SIGNAL cout0, cout1, cout2 : STD_LOGIC;
BEGIN
    -- ripple adder
    s(0) <= a(0) XOR b(0) XOR cin;
    cout0 <= (a(0) AND b(0)) OR (a(0) AND cin) OR (b(0) AND cin);

    s(1) <= a(1) XOR b(1) XOR cout0;
    cout1 <= (a(1) AND b(1)) OR (a(1) AND cout0) OR (b(1) AND cout0);

    s(2) <= a(2) XOR b(2) XOR cout1;
    cout2 <= (a(2) AND b(2)) OR (a(2) AND cout1) OR (b(2) AND cout1);

    s(3) <= a(3) XOR b(3) XOR cout2;
    cout <= (a(3) AND b(3)) OR (a(3) AND cout2) OR (b(3) AND cout2);

END Behavioral;