----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 10/25/2022 07:42:58 PM
-- Design Name: 
-- Module Name: adder4bits_tb - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity adder4bits_tb is
    --  Port ( );
end adder4bits_tb;

architecture Behavioral of adder4bits_tb is
    -- component definition
    component adder4bits is
        Port ( cin : in STD_LOGIC;
             a : in STD_LOGIC_VECTOR (3 downto 0);
             b : in STD_LOGIC_VECTOR (3 downto 0);
             s : out STD_LOGIC_VECTOR (3 downto 0);
             cout : out STD_LOGIC);
    end component;
    -- constants
    constant NUM_BITS: natural := 4;
    constant TEST_PERIOD: time := 100 ns;
    constant MAX_DELAY: time := 10 ns;

    -- stimuli signals
    signal cin, cout : std_logic;
    signal a,b,s : std_logic_vector(NUM_BITS-1 downto 0);
    -- Custom data type
    type test_data_type is record
        stimulus_a: std_logic_vector(NUM_BITS-1 downto 0);
        stimulus_b: std_logic_vector(NUM_BITS-1 downto 0);
        sum: std_logic_vector(NUM_BITS-1 downto 0);
        carry: std_logic;
    end record;
    -- Assignements and useful objects
    type template_type is array (natural range <>) of test_data_type;

    constant TEMPLATE: template_type := (
        ("0000","0000","0000",'0'),
        ("1111","0001","0000",'1'))
;

    signal template_index: natural range TEMPLATE'range := 0;


begin
    -- instantiate the component adder4bits
    uut : entity work.adder4bits(Behavioral)
        port map (
            a => a,
            b => b,
            cin => cin,
            cout => cout,
            s=>s
        );


    Stimulus_generator: process begin
        for i in template'range loop
            template_index <= i;
            a <= template(i).stimulus_a;
            b <= template(i).stimulus_b;
            cin <='0';
            wait for TEST_PERIOD;
        end loop;
        report "End of simulation. No errors found.";
    end process;

    Response_analyzer: process begin
        wait on template_index'transaction;
        wait for MAX_DELAY;
        assert s = template(template_index).sum
        report "Error at test index " & to_string(template_index) & "." severity failure;
    end process;



end Behavioral;
